searchNodes=[{"doc":"Client-driven interactive widgets for Livebook. Kino is the library used by Livebook to render rich and interactive output directly from your Elixir code. Kino renders any data structure that implements the Kino.Render protocol, falling back to the inspect/2 representation whenever an implementation is not available. The data structures supported by Kino out of the box are: VegaLite widgets Vl . new ( ... ) |&gt; Vl . data_from_series ( ... ) |&gt; ... Kino.VegaLite widgets Kino.VegaLite is an extension of VegaLite that allows data to be streamed: widget = Vl . new ( ... ) |&gt; Vl . data_from_series ( ... ) |&gt; ... |&gt; Kino.VegaLite . start ( ) |&gt; Kino . render ( ) Kino.VegaLite . push ( widget , %{ x : 1 , y : 2 } ) All others All other data structures are rendered as text using Elixir's inspect/2 .","ref":"Kino.html","title":"Kino","type":"module"},{"doc":"Sends the given term as cell output. This allows any Livebook cell to have multiple evaluation results. You can think of this function as a generalized IO.puts/2 that works for any type.","ref":"Kino.html#render/1","title":"Kino.render/1","type":"function"},{"doc":"A number of output formats supported by Livebook.","ref":"Kino.Output.html","title":"Kino.Output","type":"module"},{"doc":"Returns text_block/0 with the inspectd term.","ref":"Kino.Output.html#inspect/1","title":"Kino.Output.inspect/1","type":"function"},{"doc":"See text_block/0 .","ref":"Kino.Output.html#text_block/1","title":"Kino.Output.text_block/1","type":"function"},{"doc":"See text_inline/0 .","ref":"Kino.Output.html#text_inline/1","title":"Kino.Output.text_inline/1","type":"function"},{"doc":"See vega_lite_dynamic/0 .","ref":"Kino.Output.html#vega_lite_dynamic/1","title":"Kino.Output.vega_lite_dynamic/1","type":"function"},{"doc":"See vega_lite_static/0 .","ref":"Kino.Output.html#vega_lite_static/1","title":"Kino.Output.vega_lite_static/1","type":"function"},{"doc":"An empty output that should be ignored whenever encountered.","ref":"Kino.Output.html#t:ignored/0","title":"Kino.Output.ignored/0","type":"type"},{"doc":"Livebook cell output may be one of these values and gets rendered accordingly.","ref":"Kino.Output.html#t:t/0","title":"Kino.Output.t/0","type":"type"},{"doc":"Standalone text block.","ref":"Kino.Output.html#t:text_block/0","title":"Kino.Output.text_block/0","type":"type"},{"doc":"Regular text, adjacent such outputs can be treated as a whole.","ref":"Kino.Output.html#t:text_inline/0","title":"Kino.Output.text_inline/0","type":"type"},{"doc":"Interactive Vega-Lite graphic with data streaming capabilities. There should be a server process responsible for communication with subscribers. Communication protocol A client process should connect to the server process by sending: { :connect , pid } And expect the following reply: { :connect_reply , %{ spec : map ( ) } } The server process may then keep sending one of the following events: { :push , %{ data : list ( ) , dataset : binary ( ) , window : non_neg_integer ( ) } }","ref":"Kino.Output.html#t:vega_lite_dynamic/0","title":"Kino.Output.vega_lite_dynamic/0","type":"type"},{"doc":"Vega-Lite graphic. spec should be a valid Vega-Lite specification, essentially JSON represented with Elixir data structures.","ref":"Kino.Output.html#t:vega_lite_static/0","title":"Kino.Output.vega_lite_static/0","type":"type"},{"doc":"Protocol defining term formatting in the context of Livebook.","ref":"Kino.Render.html","title":"Kino.Render","type":"protocol"},{"doc":"Transforms the given value into a Livebook-compatible output.","ref":"Kino.Render.html#to_livebook/1","title":"Kino.Render.to_livebook/1","type":"function"},{"doc":"","ref":"Kino.Render.html#t:t/0","title":"Kino.Render.t/0","type":"type"},{"doc":"A widget wrapping VegaLite graphic. This widget allow for rendering regular VegaLite graphic and then streaming new data points to update the graphic. Examples vl_widget = Vl . new ( width : 400 , height : 400 ) |&gt; Vl . mark ( :line ) |&gt; Vl . encode_field ( :x , &quot;x&quot; , type : :quantitative ) |&gt; Vl . encode_field ( :y , &quot;y&quot; , type : :quantitative ) |&gt; Kino.VegaLite . start ( ) |&gt; Kino . render ( ) for i &lt;- 1 .. 300 do point = %{ x : i / 10 , y : :math . sin ( i / 10 ) } Kino.VegaLite . push ( vl_widget , point ) Process . sleep ( 25 ) end","ref":"Kino.VegaLite.html","title":"Kino.VegaLite","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Kino.VegaLite.html#child_spec/1","title":"Kino.VegaLite.child_spec/1","type":"function"},{"doc":"Removes all data points from the graphic dataset. Options dataset - name of the targetted dataset from the VegaLite specification. Defaults to the default anonymous dataset.","ref":"Kino.VegaLite.html#clear/2","title":"Kino.VegaLite.clear/2","type":"function"},{"doc":"Registers a callback to run periodically in the widget process. The callback is run every interval_ms milliseconds and recives the accumulated value. The callback should return either of: {:cont, acc} - the continue with the new accumulated value :halt - to no longer schedule callback evaluation The callback is run for the first time immediately upon registration.","ref":"Kino.VegaLite.html#periodically/4","title":"Kino.VegaLite.periodically/4","type":"function"},{"doc":"Appends a single data point to the graphic dataset. Options :window - the maximum number of data points to keep. This option is useful when you are appending new data points to the plot over a long period of time. dataset - name of the targetted dataset from the VegaLite specification. Defaults to the default anonymous dataset.","ref":"Kino.VegaLite.html#push/3","title":"Kino.VegaLite.push/3","type":"function"},{"doc":"Appends a number of data points to the graphic dataset. See push/3 for more details.","ref":"Kino.VegaLite.html#push_many/3","title":"Kino.VegaLite.push_many/3","type":"function"},{"doc":"Starts a widget process with the given VegaLite definition.","ref":"Kino.VegaLite.html#start/1","title":"Kino.VegaLite.start/1","type":"function"},{"doc":"","ref":"Kino.VegaLite.html#t:t/0","title":"Kino.VegaLite.t/0","type":"type"},{"doc":"Examples","ref":"examples.html","title":"Examples","type":"extras"},{"doc":"Mix . install ( [ { :vega_lite , &quot;~&gt; 0.1.0&quot; } , { :kino , &quot;~&gt; 0.1.0&quot; } ] ) alias VegaLite , as : Vl","ref":"examples.html#setup","title":"Examples - Setup","type":"extras"},{"doc":"To dynamically stream data to a plot, all you need is a regular VegaLite specification that you can pass to Kino.VegaLite.start/1 . You don't have to specify any data up-front. vl_widget = Vl . new ( width : 400 , height : 400 ) |&gt; Vl . mark ( :line ) |&gt; Vl . encode_field ( :x , &quot;x&quot; , type : :quantitative ) |&gt; Vl . encode_field ( :y , &quot;y&quot; , type : :quantitative ) |&gt; Kino.VegaLite . start ( ) Then you can push data to the plot widget at any point and see it update dynamically: for i &lt;- 1 .. 300 do point = %{ x : i / 10 , y : :math . sin ( i / 10 ) } # The :window option ensures we only show the latest # 100 data points on the plot Kino.VegaLite . push ( vl_widget , point , window : 100 ) Process . sleep ( 25 ) end You can also explicitly clear the data: Kino.VegaLite . clear ( vl_widget )","ref":"examples.html#vegalite","title":"Examples - VegaLite","type":"extras"},{"doc":"Above we saw how you can render and stream data to the plot from separate cells. However, the widget can also be rendered explicitly at any point with the Kino.render/1 function. vl_widget = Vl . new ( width : 400 , height : 400 ) |&gt; Vl . mark ( :line ) |&gt; Vl . encode_field ( :x , &quot;x&quot; , type : :quantitative ) |&gt; Vl . encode_field ( :y , &quot;y&quot; , type : :quantitative ) |&gt; Kino.VegaLite . start ( ) |&gt; Kino . render ( ) for i &lt;- 1 .. 300 do point = %{ x : i / 10 , y : :math . sin ( i / 10 ) } Kino.VegaLite . push ( vl_widget , point , window : 100 ) Process . sleep ( 25 ) end In fact, you can think of this function as a generalized IO.puts/2 that works for any type and is rendered by Livebook similarly to regular evaluation results. # Arbitrary data structures Kino . render ( [ %{ name : &quot;Jake Peralta&quot; } , %{ name : &quot;Amy Santiago&quot; } ] ) # Static plots vl = Vl . new ( width : 400 , height : 400 ) |&gt; Vl . data_from_series ( x : 1 .. 100 , y : 1 .. 100 ) |&gt; Vl . mark ( :line ) |&gt; Vl . encode_field ( :x , &quot;x&quot; , type : :quantitative ) |&gt; Vl . encode_field ( :y , &quot;y&quot; , type : :quantitative ) Kino . render ( vl ) Kino . render ( vl ) Kino . render ( &quot;Plain text&quot; ) &quot;Cell result 🚀&quot;","ref":"examples.html#kino-render-1","title":"Examples - Kino.render/1","type":"extras"},{"doc":"You may want to have a plot running forever and updating in the background. There is a dedicated Kino.VegaLite.periodically/4 function that allows you do do just that! You just need to specify the interval and the reducer callback like this, then you interact with the widget as usually. vl_widget = Vl . new ( width : 400 , height : 400 ) |&gt; Vl . mark ( :line ) |&gt; Vl . encode_field ( :x , &quot;x&quot; , type : :quantitative ) |&gt; Vl . encode_field ( :y , &quot;y&quot; , type : :quantitative ) |&gt; Kino.VegaLite . start ( ) |&gt; Kino . render ( ) # Add a callback to run every 25ms Kino.VegaLite . periodically ( vl_widget , 25 , 0 , fn i -&gt; point = %{ x : i / 10 , y : :math . sin ( i / 10 ) } # Interacting with the widget is as usual Kino.VegaLite . push ( vl_widget , point , window : 100 ) # Continue with the new accumulator value { :cont , i + 1 } end )","ref":"examples.html#periodical-updates","title":"Examples - Periodical updates","type":"extras"}]